#include "duplink.h"
#include <stdlib.h>

static HWND hEdit;
static HANDLE hThread;
BOOLEAN(_stdcall*CreateSymbolicLink)(const TCHAR*,const TCHAR*,DWORD);

void _cdecl println(const TCHAR*format,...) {
 va_list va;
 va_start(va,format);
 TCHAR buf[256];
 int l = wvnsprintf(buf,elemof(buf)-3,format,va);
 va_end(va);
 lstrcpy(buf+l,T("\r\n"));
 SendMessage(hEdit,EM_SETSEL,-1,-1);
 SendMessage(hEdit,EM_REPLACESEL,0,(LPARAM)buf);
}

DWORD CALLBACK WorkThread(void*) {
 int argc;
 WCHAR**argv=CommandLineToArgvW(GetCommandLineW(),&argc);

 treeheap = HeapCreate(HEAP_NO_SERIALIZE,0x10000,0x1000000);	// 64K, 16M

 if (argc>=2) SetCurrentDirectory(argv[1]);
 root = FileTree::newItem(T(""));
 UINT free = HeapCompact(treeheap,HEAP_NO_SERIALIZE);	// hier: 9 MB frei, also 7 MB benutzt
 println(T("heap=%u KB, dirs=%u, files=%u, kbytes=%u, links=%u"),
	(0x1000000-free)>>10,
	FileTree::c.dirs,
	FileTree::c.files,
	FileTree::c.bytes>>10,
	FileTree::c.links);
 list = const_cast<FileTree**>(root->flattenFiles());
 println(T("files=%u"),FileTree::c.files);
 qsort(list,FileTree::c.files,sizeof(FileTree*),FileTree::comparefunc);
// Die ersten 10 Dateien
 for (unsigned i=0; i<10; i++) {
  println(T("Index %u Name %s Gre %u"),
	i,
	list[i]->path,
	unsigned(list[i]->Size));
 }
 markDup(list,FileTree::c.files);

 println(T("gleich=%u Dateien, %u KB"),
	FileTree::c.equals,
	FileTree::c.equalBytes>>10);
 linkDup(list,FileTree::c.files);

 HeapDestroy(treeheap);
 GlobalFree((HGLOBAL)argv);
 println(T("Worker beendet"));
 return 0;
}

INT_PTR CALLBACK MainDlgProc(HWND Wnd,UINT msg, WPARAM wParam, LPARAM lParam) {
 switch (msg) {
  case WM_INITDIALOG: {
   hEdit = GetDlgItem(Wnd,101);
   DWORD idThread;
   hThread = CreateThread(0,0,WorkThread,0,0,&idThread);
  }return TRUE;
  case WM_SIZE: if (wParam!=SIZE_MINIMIZED && hEdit) {
   SetWindowPos(hEdit,0,0,0,GET_X_LPARAM(lParam),GET_Y_LPARAM(lParam),SWP_NOMOVE|SWP_NOZORDER);
  }break;
  case WM_COMMAND: switch (wParam) {
   case IDCANCEL: EndDialog(Wnd,(int)wParam); break;
  }
 }
 return FALSE;
}

void WinMainCRTStartup() {
 HMODULE hKernel=LoadLibraryA("Kernel32.dll");
 CreateSymbolicLink = (BOOLEAN(_stdcall*)(const TCHAR*,const TCHAR*,DWORD))GetProcAddress(hKernel,"CreateSymbolicLinkW");
 ExitProcess(DialogBox(0,MAKEINTRESOURCE(100),0,MainDlgProc));
}

/*******************
 * Hilfsfunktionen *
 *******************/

#ifdef _M_IX86
#if (_MSC_VER>=1400)
#define _alloca_probe _alloca_probe_16
#endif
extern "C" void _declspec(naked) _cdecl _alloca_probe() {
 _asm{	dec	eax
	and	al,0xFC
	sub	esp,eax			// make room
	jmp	dword ptr[esp+eax]	// fetch return address and jump
 }
}
extern "C" void _declspec(naked) _cdecl _aullshr() {_asm{
	test	cl,32
	jnz	l1
	shrd	eax,edx,cl
	shr	edx,cl
	ret
l1:	mov	eax,edx
	xor	edx,edx
	shr	eax,cl
	ret 
}}
#elif defined(_M_AMD64)
extern "C" void __chkstk() {}		// As all allocations are << 4KByte, stack checking is never needed.
#endif
